#include <io.h>
#include <ctoasm.inc>
#include <macros.inc>

#include "IntIRC.h"

.section	.text
	
; ======================================================================
;
;	Prerusovaci rutina casovace zpracovani IRC snimace
;
;	Timer 2 ... clock base 50 kHz 
;
;     Casova narocnost:
;		Dekodovani IRC		beze zmen	35 taktu	2.1875 uS
;						+/- 		53 taktu	3.31   uS
;						2* +/- 	56 taktu	3.5    uS
;
;	Maximln vytizeni procesoru 17,5%
;
; ======================================================================

.global	SIG_OUTPUT_COMPARE2
.func		SIG_OUTPUT_COMPARE2

#define	IRC	ZL
#define	temp	YH

SIG_OUTPUT_COMPARE2:			

IntIRC:

  push	r0
  in		r0, _SFR_IO_ADDR(SREG)
  push	ZH
  push	ZL
  push	temp
	
  in		IRC, _SFR_IO_ADDR(IRC_PORT)	; cteni aktualniho stavu IRC
    
  ldi		temp, MASK_PIN_A			; dekodovani grayova kodu
  sbrc	IRC, PIN_B				; je-li vyssi bit 1
  eor		IRC, temp				;   pak nizsi bit negovat
  andi	IRC, MASK_PIN_AB			; maskovat pouze bity A, B

  lds		temp, LastIRC			; vyzvednuti minuleho stavu
  sts		LastIRC, IRC			; a ulozeni noveho

  sub		IRC, temp				; rozdil aktualniho a minuleho stavu
  andi	IRC, MASK_PIN_AB			; maskovat pouze bity A,B (mozne peteeni)

  breq	enc_zero				; rozdil je 0, nedoslo k pohybu
  cpi		IRC, MASK_PIN_A			; rozdil stavu je "1"  
  breq	enc_inc				;   pricist tik
  cpi		IRC, MASK_PIN_AB			; rozdil stavu je "-1"
  breq	enc_dec				;   odecist tik
							
  lds		ZL, PreviousDir			; rozdil stavu je "2", ztrata stavu
  mov   ZH, ZL				;   zjistit prechozi smer pohybu
  lsl		ZL					; nasobit 2-mi, 
  asr   ZH					; pricteme, nebo odecteme 2 tiky
  rjmp	enc_add				

enc_inc:	
  ldi		ZL, 1					; budeme pricitat 1 tik
  clr		ZH
  rjmp	enc_store

enc_dec:
  ldi		ZL, -1				; budeme odecitat 1 tik
  mov		ZH, ZL

enc_store:	
  sts		PreviousDir, ZL			; uschova aktualniho smeru pohybu
	
enc_add:
  lds		temp, EncoderPosition		; vypocet nove hodnoty pozice
  add		temp, ZL				;   enkoderu
  sts		EncoderPosition, temp
  lds		temp, EncoderPosition+1
  adc		temp, ZH
  sts		EncoderPosition+1, temp

enc_zero:
  pop		temp
  pop		ZL
  pop		ZH
  out		_SFR_IO_ADDR(SREG), r0
  pop		r0

  reti

.endfunc
